;*********************************************************************************
;*********************************************************************************
;                          BAND PROCESS
;
;  Contributions from M.Hasenfratz, WA6FXT for addition of WARC bands to menu
;
;*********************************************************************************
;*********************************************************************************

Band_process:
        brclr   BandPB,porth,*          ;await button release
        jsr     ResetAutoTimers         ;Reset LiteOff timer since user touched controls
        tone_off                        ;turn tone off while in Band menu
        jsr     wait100ms
        jsr     LCD_Clear
        ldhx    #Band_msg
        jsr     disp_msg                ;display "Band Selection" on 1st line

        ldhx    #BandCmndTable          ;set up pointer to DiagCmndTable
;;drop        sthx    CmndTabPntr
        sthx    CmndTabStart
        ldhx    #BandMsgTable           ;set up pointer to DiagMsgTable
        sthx    MsgTabStart
;;drop        sthx    MsgTabPntr
        sthx    msg_pointer
        clr     msg_cntr                ;counter used as index into Msg Table
        jmp     get_dial_selection

             ; Low Band Selection (1-10 MHz)

LowBand:   ldhx    #low_edges
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
low_edges: fcb     00,01,00,00,00,00,00
           fcb     01,00,00,00,00,00,00

             ; Mid Band Selection (10-20 MHz)

MidBand:   ldhx    #mid_edges
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
mid_edges: fcb     01,00,00,00,00,00,00
           fcb     02,00,00,00,00,00,00

             ; Hi Band Selection (20-30 MHz)

HiBand:    ldhx    #hi_edges
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
hi_edges:  fcb     02,00,00,00,00,00,00
           fcb     03,00,00,00,00,00,00

             ; 160m Band Selection (1.8-2.0 MHz)

Band160:   ldhx    #m160_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m160_edge: fcb     00,01,08,00,00,00,00
           fcb     00,02,00,00,00,00,00

             ; 80m Band Selection (3.5-4.0 MHz)

Band80:    ldhx    #m80_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m80_edge:  fcb     00,03,05,00,00,00,00
           fcb     00,04,00,00,00,00,00

             ; 40m Band Selection (7.0-7.3 MHz)

Band40:    ldhx    #m40_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m40_edge:  fcb     00,07,00,00,00,00,00
           fcb     00,07,03,00,00,00,00

             ; 30m Band Selection (10.1-10.15 MHz)

Band30:    ldhx    #m30_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m30_edge:  fcb     01,00,01,00,00,00,00
           fcb     01,00,01,05,00,00,00

             ; 20m Band Selection (14.0-14.35 MHz)

Band20:    ldhx    #m20_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m20_edge:  fcb     01,04,00,00,00,00,00
           fcb     01,04,03,05,00,00,00

             ; 17m Band Selection (18.068-18.168 MHz)

Band17:    ldhx    #m17_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m17_edge:  fcb     01,08,00,06,08,00,00
           fcb     01,08,01,06,08,00,00

             ; 15m Band Selection (21.0-21.45 MHz)

Band15:    ldhx    #m15_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m15_edge:  fcb     02,01,00,00,00,00,00
           fcb     02,01,04,05,00,00,00

             ; 12m Band Selection (24.890-24.990 MHz)

Band12:    ldhx    #m12_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m12_edge:  fcb     02,04,08,09,00,00,00
           fcb     02,04,09,09,00,00,00

             ; 10m Band Selection (28.0-29.7 MHz)

Band10:    ldhx    #m10_edge
           jsr     SetEdges		; set the band edges 02/12/05 (mlh)
           jmp     ExitBand
m10_edge:  fcb     02,08,00,00,00,00,00
           fcb     02,09,07,00,00,00,00

             ; Set Scan_Start & Scan_End

SetEdges:  lda     0,x
           sta     Scan_Start+0		; Corrected source and destition 02/12/05 (mlh)
           lda     1,x
           sta     Scan_Start+1
           lda     2,x
           sta     Scan_Start+2
           lda     3,x
           sta     Scan_Start+3
           lda     4,x
           sta     Scan_Start+4
           lda     5,x
           sta     Scan_Start+5
           lda     6,x
           sta     Scan_Start+6
           lda     7,x
           sta     Scan_End+0
           lda     8,x
           sta     Scan_End+1
           lda     9,x
           sta     Scan_End+2
           lda     10,x
           sta     Scan_End+3
           lda     11,x
           sta     Scan_End+4
           lda     12,x
           sta     Scan_End+5
           lda     13,x
           sta     Scan_End+6
           rts

             ; Custom Band Selection
CustomBand:
        mov     Custom_Start+0,Scan_Start+0     ;set START frequency registers (MSB) to (LSB)
        mov     Custom_Start+1,Scan_Start+1
        mov     Custom_Start+2,Scan_Start+2
        mov     Custom_Start+3,Scan_Start+3
        mov     Custom_Start+4,Scan_Start+4
        mov     Custom_Start+5,Scan_Start+5
        mov     Custom_Start+6,Scan_Start+6
        mov     Custom_End+0,Scan_End+0         ;set END frequency registers (MSB) to (LSB)
        mov     Custom_End+1,Scan_End+1
        mov     Custom_End+2,Scan_End+2
        mov     Custom_End+3,Scan_End+3
        mov     Custom_End+4,Scan_End+4
        mov     Custom_End+5,Scan_End+5
        mov     Custom_End+6,Scan_End+6

ExitBand:
        brclr   ENC_PB,portf,*                  ;wait here until Encoder PB released
        mov     Scan_start+0,F_min+0            ;Put lowest freq in selected band into display registers
        mov     Scan_start+1,F_min+1            ;  so display goes there when we go back to to Impedance mode
        mov     Scan_start+2,F_min+2
        mov     Scan_start+3,F_min+3
        mov     Scan_start+4,F_min+4
        mov     Scan_start+5,F_min+5
        mov     Scan_start+6,F_min+6

        jmp     Impedance                       ;Go back to Impedance mode and put freq at low band edge


Band_msg:    fcb  'Band Selection',0
Low_msg:     fcb  'Band: 1-10 MHz',0
Mid_msg:     fcb  'Band: 10-20 MHz',0
Hi_msg:      fcb  'Band: 20-30 MHz',0
Mtr160_msg:  fcb  'Band: 160m',0
Mtr80_msg:   fcb  'Band:  80m',0
Mtr40_msg:   fcb  'Band:  40m',0
Mtr30_msg:   fcb  'Band:  30m',0
Mtr20_msg:   fcb  'Band:  20m',0
Mtr17_msg:   fcb  'Band:  17m',0
Mtr15_msg:   fcb  'Band:  15m',0
Mtr12_msg:   fcb  'Band:  12m',0
Mtr10_msg:   fcb  'Band:  10m',0
Custom_msg:  fcb  'Custom Band',0

;--------------------------
;   Band JUMP TABLE

BandCmndTable:
        fdb     MidBand
        fdb     LowBand
        fdb     Band160
        fdb     Band80
        fdb     Band40
        fdb     Band30
        fdb     Band20
        fdb     Band17
        fdb     Band15
        fdb     Band12
        fdb     Band10
        fdb     CustomBand
        fdb     HiBand

;---------------------------
;   Band MESSAGE TABLE

BandMsgTable:
        fcb     '10-20 MHz',0         ;CW item
        fcb     '1-10 MHz',0          ;1st item displayed
        fcb     '160m Band',0         ;CCW item
        fcb     ' 80m Band',0         ;CCW item
        fcb     ' 40m Band',0         ;CCW item
        fcb     ' 30m Band',0         ;CCW item
        fcb     ' 20m Band',0         ;CCW item
        fcb     ' 17m Band',0         ;CCW item
        fcb     ' 15m Band',0         ;CCW item
        fcb     ' 12m Band',0         ;CCW item
        fcb     ' 10m Band',0         ;CCW item
        fcb     'Custom Band',0       ;CCW item
        fcb     '20-30 MHz',0
        fcb     0                     ;end of list character
