;****************************************************************************
; Debug Print Routines

;-------------------------------------------
; Debug Print Raw - Debug routine to print raw voltages for Vf, Vr, Vz, Va
; to serial terminal

dpr_raw:
        psha
        pshhx
        lda     debug_flag        ;<<<<<<<<< if DEBUG set, then print data to screen
        tsta
        beq     pf1
        lda     Vf
        jsr     _byte_sp
        lda     Vr
        jsr     _byte_sp
        lda     Vz
        jsr     _byte_sp
        lda     Va
        jsr     _byte_sp
        jsr     _crlf
pf1:    pulhx
        pula
        rts

;-------------------------------------------
; Debug Print Raw - Debug routine to print HX to serial terminal

print_HX:
        psha
        pshhx
        tha
        jsr     _byte_sp
        txa
        jsr     _byte_sp
        pulhx
        pula
        rts

;-------------------------------------------
; Debug Print A - Debug routine to print A to serial terminal w/CRLF

dpr_A:
        psha
        pshhx
        lda     debug_flag        ;if DEBUG set, then print data to screen
        tsta
        beq     dpr_A1
        lda     3,sp
        jsr     _byte_sp
        jsr     _crlf
dpr_A1: pulhx
        pula
        rts

;-------------------------------------------
; Debug Print A - Debug routine to print A to serial terminal w/o CRLF

dpr_A_nocr:
        psha
        pshhx
        lda     debug_flag        ;if DEBUG set, then print data to screen
        tsta
        beq     dpr_A2
        lda     3,sp
        jsr     _byte_sp
dpr_A2: pulhx
        pula
        rts

;-------------------------------------------
; Print Raw - Debug routine to print A to serial terminal w/ CRLF

print_A:
        psha
        pshhx
        jsr     _byte_sp
        jsr     _crlf
        pulhx
        pula
        rts

;-------------------------------------------
; Debug Print A - Debug routine to print A to serial terminal w/o CRLF

print_A_nocr:
        psha
        pshhx
        jsr     _byte_sp
        pulhx
        pula
        rts

;-------------------------------------------
; Debug Print Intacc1 to terminal

dpr_acc1:
        psha
        pshhx
        lda     debug_flag        ;if DEBUG set, then print data to screen
        tsta
        beq     dpr1
        ldhx    #intacc1
        bsr     Print4hx
        jsr     _crlf
dpr1:   pulhx
        pula
        rts

;-------------------------------------------
; Print Intacc1 to terminal

print_acc1:
        psha
        pshhx
        ldhx    #intacc1
        bsr     Print4hx
        jsr     _crlf
        pulhx
        pula
        rts

;-------------------------------------------
; Debug Print intacc2 to terminal

dpr_acc2:
        psha
        pshhx
        lda     debug_flag        ;if DEBUG set, then print data to screen
        tsta
        beq     dpr2
        ldhx    #intacc2
        bsr     Print4hx
        jsr     _crlf
dpr2:   pulhx
        pula
        rts

;-------------------------------------------
            ;Print 4 bytes starting at H:X
Print4hx:
        pshhx
        lda     0,x
        jsr     _pbyte
        pulhx
        pshhx
        lda     1,x
        jsr     _pbyte
        pulhx
        pshhx
        lda     2,x
        jsr     _pbyte
        pulhx
        pshhx
        lda     3,x
        jsr     _byte_sp
p4:     pulhx
        rts

;-------------------------------------------
; Debug Print CRLF to terminal

dpr_crlf:
        psha
        pshhx
        lda     debug_flag        ;if DEBUG set, then print data to screen
        tsta
        beq     pcr1
        jsr     _crlf
pcr1:   pulhx
        pula
        rts
